import socket
import select
import signal
import datetime
import time
import serial
import lectura
import pygame
import sys, pygame
from pygame.locals import *


def handler( signum, frame):
	print 'error'	
	exit()

pygame.init()


njoy = pygame.joystick.get_count()
print "Number of joysticks detected = ",njoy

for j in range(njoy):
    gamepad = pygame.joystick.Joystick(j)
    gamepad.init()
    print "Joystick #",j+1,"(", gamepad.get_name(),")"

clock = pygame.time.Clock()
keepGoing = True

# esta funcion sirve para que cuando detecta el cierre del programa forzado efectue la funcion handler, que sera nuestro tratamiento de error
signal.signal(signal.SIGINT, handler)
print 'Iniciando el programa'
socketlisten = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
# creamos el socket-lectura
#socketlisten.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
# cambiamos las opciones para que el socket sea liberado cada vez k se usa
socketlisten.bind(('0.0.0.0',9999))
# creamos socket-escritura
socketwrite = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
# creamos el socket servidor
#socketwrite.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
# cambiamos las opciones para que el socket sea liberado cada vez k se usa
socketwrite.bind(('0.0.0.0',0))
print 'Creamos y damos direccion al objetos lectura/escritura'
# 5 escuchas
# Creamos un conjunto
print 'Introducimos el objeto socket-lectura'
Lista = list()
print 'Introducimos el objeto socket-escritura'
Lista.append(socketlisten)
print 'Entramos en el bucle de select'
adelante = 0
atras = 0
izquierda = 0
derecha = 0
parar = 0

camupdo = 0
camrl = 0
camcent = 0
camstop = 0

while keepGoing:
	cadena = ''
	clock.tick(30)
	for event in pygame.event.get():
		if event.type == JOYAXISMOTION:
			###print "Joystick:", event.joy, " axis:", event.axis, " value:", event.value
			if(event.axis == 1):
				if(event.value<0):
					if(adelante == 0):
						cadena = 'GET /mov-protocol/front HTTP/1.1'
						print 'Direccion: Adelante'
						adelante = 1
						atras = 0
						parar = 0
				elif(event.value>0):
					if(atras == 0):
						cadena = 'GET /mov-protocol/back HTTP/1.1'
						print 'Direccion: Atras'
						adelante = 0
						atras = 1
						parar = 0
			if(event.axis == 0):
				if(event.value<-0.2):
					if(izquierda == 0):
						cadena = 'GET /mov-protocol/right HTTP/1.1'
						print 'Direccion: Izquierda'
						izquierda = 1
						derecha = 0
						parar = 0
				elif(event.value>0.2):
					if(derecha == 0):
						cadena = 'GET /mov-protocol/left HTTP/1.1'
						print 'Direccion: Derecha'
						derecha = 1
						izquierda = 0
						parar = 0
			if(parar == 1):
				if(event.axis == 3):
					if(event.value<0):
						if(camrl < 3):
							cadena = 'GET /mov-protocol/camri HTTP/1.1'
							print 'Direccion Camara: Izquierda'
							camrl = camrl +1
							camcent = 0
							camstop = 0
					elif(event.value>0):
						if(camrl > -3):
							cadena = 'GET /mov-protocol/camle HTTP/1.1'
							print 'Direccion Camara: Derecha'
							camrl = camrl -1
							camcent = 0
							camstop = 0
				if(event.axis == 4):
					if(event.value<-0.1):
						if(camupdo < 3):
							cadena = 'GET /mov-protocol/camdo HTTP/1.1'
							print 'Direccion Camara: Arriba'
							camupdo = camupdo +1
							camcent = 0
							camstop = 0
					elif(event.value>0.1):
						if(camupdo > -3):
							cadena = 'GET /mov-protocol/camup HTTP/1.1'
							print 'Direccion Camara: Abajo'
							camupdo = camupdo = camupdo -1
							camcent = 0
							camstop = 0
	
		elif event.type == JOYHATMOTION:
			if(event.value == (0,1)):
				cadena = 'GET /mov-protocol/front HTTP/1.1'
				print 'Direccion: Adelante'
				parar = 0
			if(event.value == (0,-1)):
				cadena = 'GET /mov-protocol/back HTTP/1.1'
				print 'Direccion: Atras'
				parar = 0
			if(event.value == (1,0)):
				cadena = 'GET /mov-protocol/left HTTP/1.1'
				print 'Direccion: Derecha'
				parar = 0
			if(event.value == (-1,0)):
				cadena = 'GET /mov-protocol/right HTTP/1.1'
				print 'Direccion: Izquierda'
				parar = 0

		elif event.type == JOYBUTTONDOWN:
			###print "Joystick:", event.joy, " button", event.button, "pressed"
			if(event.button == 0):
				if(parar == 0):
					cadena = 'GET /mov-protocol/stop HTTP/1.1'
					print 'Direccion: Parada'
				if(parar == 1):
					if(camstop == 0):
						cadena = 'GET /mov-protocol/camst HTTP/1.1'
						print 'Direccion Camara: Parada'
						camdown = 0
						camup = 0
						camrigth = 0
						camleft = 0
						camcent = 0
						camstop = 1
				parar = 1
			if(event.button == 9):
				cadena = 'GET /mov-protocol/claxon HTTP/1.1'
				print 'Usar el Claxon'
			if(event.button == 7):
				print 'EXIT'
				keepGoing = False
			if(event.button == 2):
				if(parar == 1):
					if(camcent == 0):
						print 'Centrar Camara'
						cadena = 'GET /mov-protocol/camce HTTP/1.1'
						camrl = 0
						camupdo = 0
						camcent = 1
						camstop = 0
			
		if event.type == pygame.QUIT:
			keepGoing = False
		socketwrite.sendto(cadena, ('192.168.0.109',9999))

pygame.quit()
